
Redmine - Defect #33355

TypeError when attempting to update a user with a blank email address

2020-04-26 09:54 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version: 4.1.2   

Resolution:  Affected version:  

Description

Started PATCH "/users/3" for 127.0.0.1 at 2020-04-26 16:42:34 +0900

Processing by UsersController#update as HTML

.

.

.

ActionView::Template::Error (no implicit conversion of nil into String):

     7:

     8: <%=

     9:   page_title = title [l(:label_user_plural), users_path], @user.login

    10:   page_title.insert(page_title.rindex(' ') + 1, avatar(@user))

    11: %>

    12:

    13: <%= render_tabs user_settings_tabs %>

app/views/users/edit.html.erb:10:in `insert'

app/views/users/edit.html.erb:10:in `_app_views_users_edit_html_erb___718898119020271380_701996167

90460'

app/controllers/users_controller.rb:180:in `block (2 levels) in update'

app/controllers/users_controller.rb:179:in `update'

lib/redmine/sudo_mode.rb:64:in `sudo_mode'

 Steps to reproduce:

1. Enable "Use Gravatar user icons" (Setting.gravatar_enabled)

2. Update any user with a blank email address from the Administration page

3. "Email cannot be blank" error is expected but actually you will encounter the exception

Related issues:

Related to Redmine - Patch #5899: Display user's gravatar when editing profile Closed 2010-07-18

Associated revisions

Revision 20562 - 2020-12-03 16:14 - Go MAEDA

TypeError when attempting to update a user with a blank email address (#33355).

Patch by Go MAEDA.

Revision 20563 - 2020-12-04 01:40 - Go MAEDA

Merged r20562 from trunk to 4.1-stable (#33355).

History

#1 - 2020-04-28 06:39 - Mizuki ISHIKAWA

- File diff.patch added

I've attached a patch to fix the problem.

#2 - 2020-04-28 11:51 - Go MAEDA

I'm not sure which is more appropriate, changing the API of AvatarsHelper as suggested in #note-1, or changing app/views/users/edit.html.erb as

follows.
diff --git a/app/views/users/edit.html.erb b/app/views/users/edit.html.erb

index 2a8b6707f..786630869 100644

--- a/app/views/users/edit.html.erb

+++ b/app/views/users/edit.html.erb

@@ -7,7 +7,7 @@

 <%=

   page_title = title [l(:label_user_plural), users_path], @user.login

-  page_title.insert(page_title.rindex(' ') + 1, avatar(@user))

+  page_title.insert(page_title.rindex(' ') + 1, avatar(@user).to_s)

 %>

 <%= render_tabs user_settings_tabs %>

#4 - 2020-11-17 07:43 - Mizuki ISHIKAWA

Go MAEDA wrote:

I'm not sure which is more appropriate, changing the API of AvatarsHelper as suggested in #note-1, or changing app/views/users/edit.html.erb

as follows.

[...]

 The solution you have proposed looks simpler and better.

#5 - 2020-11-30 10:41 - Go MAEDA

- File 33355.patch added

Here is a patch based on #33355#note-2.

#6 - 2020-11-30 10:41 - Go MAEDA

- Target version set to Candidate for next minor release

#7 - 2020-12-01 02:55 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.1.2

Setting the target version to 4.1.2.

#8 - 2020-12-03 16:14 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

Committed the patch.

#9 - 2020-12-04 00:35 - Go MAEDA

- Related to Patch #5899: Display user's gravatar when editing profile added

#10 - 2020-12-04 01:40 - Go MAEDA

- Status changed from Resolved to Closed

Files

diff.patch 1008 Bytes 2020-04-28 Mizuki ISHIKAWA

33355.patch 1.23 KB 2020-11-30 Go MAEDA
